package edu.nyu.scps.preferences;

import java.text.DateFormat;
import java.util.Date;

import android.app.Activity;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class PreferencesActivity extends Activity {
	public static final String PREFERENCES_FILENAME = "preferencesFilename";
	boolean showDate;	//true to show date, false to show time
	TextView textView;
	Button button;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		textView = (TextView)findViewById(R.id.textView);
		button = (Button)findViewById(R.id.button);

		button.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				//Toggle date vs. time.
				PreferencesActivity.this.showDate = !PreferencesActivity.this.showDate;
				PreferencesActivity.this.update();
			}
		});
		
		//Restore the preferences.
		SharedPreferences sharedPreferences =
			getSharedPreferences(PREFERENCES_FILENAME, MODE_PRIVATE);
		//defaults to true if it hasn't been set yet
		showDate = sharedPreferences.getBoolean("showDate", true);

		update();
	}
	
	@Override
	protected void onPause() {
		super.onPause();

		//Save the preferences.
		SharedPreferences sharedPreferences =
			getSharedPreferences(PREFERENCES_FILENAME, MODE_PRIVATE);
		SharedPreferences.Editor editor = sharedPreferences.edit();
		editor.putBoolean("showDate", showDate);
		editor.commit();	//the changes
	}
	
	private void update() {
		//A DateFormat converts a Date object into a string.
		DateFormat format =
			showDate ? DateFormat.getDateInstance() : DateFormat.getTimeInstance();
		String s = format.format(new Date());
		textView.setText(s);
		button.setText(showDate ? "show time" : "show date");
	}
}